﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

using CamBam;
using CamBam.UI;
using CamBam.Util;
using CamBam.CAD;


namespace Mortaise
{
    public class Mortaise2D
    {
        protected static CamBamUI _ui;

        // This is the main entry point into the plugin.
        public static void InitPlugin(CamBamUI ui)
        {
            // Store a reference to the CamBamUI object passed to InitPlugin
            _ui = ui;

            // Create a new menu item in the top Plugins menu
            ToolStripMenuItem mi = new ToolStripMenuItem();
            mi.Text = "Preparation 2D D'une Mortaise";
            mi.Click += new EventHandler(DrawEllipse_Click);
            ui.Menus.mnuPlugins.DropDownItems.Add(mi);
        }

        static void DrawEllipse_Click(object sender, EventArgs e)
        {
            // Set the width of the mortaise
            double width_mortaise=0;

            width_mortaise = Convert.ToDouble(ThisApplication.PromptForValue("Largeur de la mortaise", "Génération mortaise", width_mortaise.GetType()));
            // ThisApplication.MsgBox(Convert.ToString(width_mortaise));

            // Set the lenght of the Mortaise
            double length_mortaise = 0;

            length_mortaise = Convert.ToDouble(ThisApplication.PromptForValue("Longueur de la mortaise", "Génération mortaise", length_mortaise.GetType()));
            // ThisApplication.MsgBox(Convert.ToString(length_mortaise));

            // Set the Tool dia
            double tool_dia = 0;

            tool_dia = Convert.ToDouble(ThisApplication.PromptForValue("Diamètre de l'outil", "Génération mortaise", tool_dia.GetType()));
            // ThisApplication.MsgBox(Convert.ToString(tool_dia));

            // Set piece of wood width
            double piece_wood_width = 0;

            piece_wood_width = Convert.ToDouble(ThisApplication.PromptForValue("Largeur piece de bois", "Génération mortaise", piece_wood_width.GetType()));

            // Set distance / X=0
            double decal_X = 0;

            decal_X = Convert.ToDouble(ThisApplication.PromptForValue("Position en X de la Mortaise", "Génération mortaise", decal_X.GetType()));

            int suprim_suivant_x = 0;
            suprim_suivant_x = Convert.ToInt32(ThisApplication.PromptForValue("Nbre de suppression en X", "Génération mortaise", suprim_suivant_x.GetType()));

            int suprim_suivant_y = 0;
            suprim_suivant_y = Convert.ToInt32(ThisApplication.PromptForValue("Nbre de suppression en Y", "Génération mortaise", suprim_suivant_y.GetType()));

            PolyRectangle rect = new PolyRectangle(new CamBam.Geom.Point3F(decal_X, (piece_wood_width - width_mortaise )/ 2, 0), length_mortaise , width_mortaise );

            Line piece_haute = new Line(new CamBam.Geom.Point2F(0, 0), new CamBam.Geom.Point2F(decal_X+ length_mortaise+100, 0));
            Line piece_basse = new Line(new CamBam.Geom.Point2F(0, piece_wood_width), new CamBam.Geom.Point2F(decal_X + length_mortaise + 100, piece_wood_width));
            Line piece_gauche = new Line(new CamBam.Geom.Point2F(0, 0), new CamBam.Geom.Point2F(0, piece_wood_width));

            int nb_width = (Convert.ToInt32((width_mortaise / tool_dia) - 0.2)) +1 ;
            nb_width = nb_width - suprim_suivant_y;
            int nb_length =( Convert.ToInt32((length_mortaise / tool_dia )- 0.2)) +1 ;
            nb_length = nb_length - suprim_suivant_x;


            double coor_y = (piece_wood_width - width_mortaise) / 2 + tool_dia * 0.5;

            for (int nb_loop_y = 0; nb_loop_y <= nb_width; nb_loop_y++)
            {
                double coor_x = decal_X + tool_dia * 0.5;
                for (int nb_loop_x = 0; nb_loop_x <= nb_length; nb_loop_x++)
                {


                    // Add a point to the polyine

                    Circle new_cercle = new Circle(new CamBam.Geom.Circle2F(new CamBam.Geom.Point2F(coor_x, coor_y), tool_dia / 2));
                    _ui.ActiveView.CADFile.Add(new_cercle);
                    coor_x = coor_x + (length_mortaise - tool_dia) / nb_length;
                }
                coor_y = coor_y + (width_mortaise - tool_dia) / nb_width;
            }
            // Then add it to the active drawing.

            _ui.ActiveView.CADFile.Add(rect);
            _ui.ActiveView.CADFile.Add(piece_haute);
            _ui.ActiveView.CADFile.Add(piece_basse);
            _ui.ActiveView.CADFile.Add(piece_gauche);

            // Refresh the view to show the ellipse immediately
            _ui.ActiveView.RefreshView();


        }

        private static void sprintf(object str, string v, int num)
        {
            throw new NotImplementedException();
        }
    }
}
