﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

using CamBam;
using CamBam.UI;
using CamBam.Util;
using CamBam.CAD;


namespace Tenon
{
    public class Tenon2D
    {
        protected static CamBamUI _ui;

        // This is the main entry point into the plugin.
        public static void InitPlugin(CamBamUI ui)
        {
            // Store a reference to the CamBamUI object passed to InitPlugin
            _ui = ui;

            // Create a new menu item in the top Plugins menu
            ToolStripMenuItem mi = new ToolStripMenuItem();
            mi.Text = "Preparation 2D D'un Tenon";
            mi.Click += new EventHandler(DrawTenon_Click);
            ui.Menus.mnuPlugins.DropDownItems.Add(mi);
        }

        static void DrawTenon_Click(object sender, EventArgs e)
        {
            // Set the width of the Tenon
            double width_Tenon = 0;

            width_Tenon = Convert.ToDouble(ThisApplication.PromptForValue("Largeur du Tenon", "Génération 2D Tenon", width_Tenon.GetType()));
            // ThisApplication.MsgBox(Convert.ToString(width_Tenon));

            // Set the lenght of the Tenon
            double length_Tenon = 0;

            length_Tenon = Convert.ToDouble(ThisApplication.PromptForValue("Longueur du Tenon", "Génération 2D Tenon", length_Tenon.GetType()));
            // ThisApplication.MsgBox(Convert.ToString(length_Tenon));

            // Set the Tool dia
            double tool_dia = 0;

            tool_dia = Convert.ToDouble(ThisApplication.PromptForValue("Diamètre de l'outil", "Génération 2D Tenon", tool_dia.GetType()));
            // ThisApplication.MsgBox(Convert.ToString(tool_dia));

            // Set piece of wood width
            double piece_wood_width = 0;

            piece_wood_width = Convert.ToDouble(ThisApplication.PromptForValue("Largeur piece de bois", "Génération 2D Tenon", piece_wood_width.GetType()));

            // dessin de la piece de bois cible 

            // PolyRectangle rect = new PolyRectangle(new CamBam.Geom.Point3F(decal_X, (piece_wood_width - width_Tenon) / 2, 0), length_Tenon, width_Tenon);
            //   on fait de ligne 2 gravures de l'exterieur vers l'interieur pour eviter l'eclatement du bois
            Line gravure_1 = new Line(new CamBam.Geom.Point2F(length_Tenon- tool_dia/2, -tool_dia/2), new CamBam.Geom.Point2F(length_Tenon - tool_dia / 2, piece_wood_width / 2+ tool_dia/2));
            Line gravure_2 = new Line(new CamBam.Geom.Point2F(length_Tenon- tool_dia/2, piece_wood_width+tool_dia/2), new CamBam.Geom.Point2F(length_Tenon - tool_dia / 2, piece_wood_width/2));

            Line tenon_gauche = new Line(new CamBam.Geom.Point2F(0, (piece_wood_width- width_Tenon)/2), new CamBam.Geom.Point2F(length_Tenon, (piece_wood_width - width_Tenon) / 2));
            Line tenon_bas = new Line(new CamBam.Geom.Point2F(0, (piece_wood_width + width_Tenon) / 2), new CamBam.Geom.Point2F(length_Tenon, (piece_wood_width + width_Tenon) / 2));
            Line tenon_haut = new Line(new CamBam.Geom.Point2F(0, (piece_wood_width - width_Tenon) / 2), new CamBam.Geom.Point2F(0, (piece_wood_width + width_Tenon) / 2));
            Line piece_gauche = new Line(new CamBam.Geom.Point2F(length_Tenon, 0), new CamBam.Geom.Point2F(length_Tenon, piece_wood_width));
            Line piece_haute = new Line(new CamBam.Geom.Point2F(length_Tenon, piece_wood_width), new CamBam.Geom.Point2F(length_Tenon + 100, piece_wood_width));
            Line piece_bas = new Line(new CamBam.Geom.Point2F(length_Tenon, 0), new CamBam.Geom.Point2F(length_Tenon+100, 0));

            //dessin du tenon 

            PolyRectangle tenon = new PolyRectangle(new CamBam.Geom.Point3F(-tool_dia/2, (piece_wood_width - width_Tenon) / 2- tool_dia/2, 0), length_Tenon - tool_dia/2 + 2, width_Tenon+ tool_dia);

            // Then add it to the active drawing.
            _ui.ActiveView.CADFile.Add(gravure_1);
            _ui.ActiveView.CADFile.Add(gravure_2);
            _ui.ActiveView.CADFile.Add(tenon_gauche);
            _ui.ActiveView.CADFile.Add(tenon_bas);
            _ui.ActiveView.CADFile.Add(tenon_haut);
            _ui.ActiveView.CADFile.Add(piece_gauche);
            _ui.ActiveView.CADFile.Add(piece_haute);
            _ui.ActiveView.CADFile.Add(piece_bas);
            _ui.ActiveView.CADFile.Add(tenon);

            string information = "Commencer par graver la droite ID = " + Convert.ToString(gravure_1.ID) + " en selectionnant l'option '' Mode d'optimisation = aucun ''. Puis faire de même avec la droite ID = " + Convert.ToString(gravure_2.ID) + ". Enfin faire un pocketing du rectangle ID = " + Convert.ToString(tenon.ID) + " avec un recouvrement = 0.8. Les 2 droites doivent etre parcourues de l'exterieur vers l'interieur afin d'eviter l'eclatement du bois. C'est pour cette raison que l'on utilise l'option optimisation = aucun dans le cas ou il y a plusieur passes en profondeur.";

            ThisApplication.MsgBox(information);


            // Refresh the view to show the ellipse immediately
            _ui.ActiveView.RefreshView();


        }

        private static void sprintf(object str, string v, int num)
        {
            throw new NotImplementedException();
        }
    }
}
