﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

using CamBam;
using CamBam.UI;
using CamBam.Util;
using CamBam.CAD;


namespace CBPluginDemo
{
    public class MyPlugin
    {
        protected static CamBamUI _ui;

        // This is the main entry point into the plugin.
        public static void InitPlugin(CamBamUI ui)
        {
            // Store a reference to the CamBamUI object passed to InitPlugin
            _ui = ui;

            // Create a new menu item in the top Plugins menu
            ToolStripMenuItem mi = new ToolStripMenuItem();
            mi.Text = "Draw Ellipse a pierre";
            mi.Click += new EventHandler(DrawEllipse_Click);
            ui.Menus.mnuPlugins.DropDownItems.Add(mi);
        }

        static void DrawEllipse_Click(object sender, EventArgs e)
        {
            // Set the width of the elipse
            double width = 35;

            // Set the height of the elipse
            double height = 300;

            // Set steps to the number of line segments to use to approcximate the elipse
            // larger number will be smoother but slower.
            double steps = 100;

            double s, t, x, y;

            // Create a polyline object
            Polyline poly = new Polyline();

            for (s = 0; s < steps; s++)
            {
                t = 2 * Math.PI * s / steps;
                x = width * Math.Cos(t);
                y = height * Math.Sin(t);

                // Add a point to the polyine
                poly.Add(x, y, 0);
            }

            // Close the polyline
            poly.Closed = true;

            Circle cercle = new Circle(new CamBam.Geom.Point2F(10,30),40);

            PolyRectangle rect = new PolyRectangle(new CamBam.Geom.Point3F(10, 30, 0), 30, 50);

            double rep =0;
            rep = Convert.ToDouble(ThisApplication.PromptForValue("Génération mortaise", "Longueur de la mortaise", rep.GetType()));
            ThisApplication.MsgBox(Convert.ToString(rep));

            // Then add it to the active drawing.
            _ui.ActiveView.CADFile.Add(poly);
            _ui.ActiveView.CADFile.Add(cercle);
            _ui.ActiveView.CADFile.Add(rect);

            // Refresh the view to show the ellipse immediately
            _ui.ActiveView.RefreshView();

            int num = cercle.ID;
            ThisApplication.MsgBox(Convert.ToString(num));

        }

        private static void sprintf(object str, string v, int num)
        {
            throw new NotImplementedException();
        }
    }
}